#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
//#include <queue>
//#include <set>
//#include <map>
//#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

FILE *f = 0;
int tst = 43;

void close() {
	if (f != 0) {
	   	fclose(f);
   		f = 0;
	}
}

FILE *open() {
	close();
	char fname[10];
	sprintf(fname, "%.2d", ++tst);
	cerr << tst << endl;
	return f = fopen(fname, "wt");
}

int random(int value)
{
	return ((((unsigned int)rand()) << 15) ^ ((unsigned int)rand())) % value;
}

void outdata() {
}

void solve() {
}

void useInt64() {
	open();
	fprintf(f, "%d %d\n", 200000, 1);
	forn(i, 200000) fprintf(f, "%d ", 200000);
	fprintf(f, "\n%d %d %d\n", 0, 1, 200000);
	close();
}

void sample() {
	open();
	fprintf(f, "5 6\n1 2 3 4 5\n0 1 5\n0 2 4\n1 2 4\n0 1 3\n0 4 5\n0 3 5\n");
}

void outNrandom(int n, int maxR) {
	forn(i, n) {
		if (i > 0) fprintf(f, " ");
		fprintf(f, "%d", random(maxR) + 1);
	}
	fprintf(f, "\n");
}

void eqSegmentLength(int n, int m, int len, int maxR, int p = 50) {
	open();
	assert(n > len);
	vector< pair<int, int> > seg;
	fprintf(f, "%d %d\n", n, m);
	outNrandom(n, maxR);
	forn(i, m) {
		int clen = max(1, min(len + (1 - 2 * random(2)) * (len / 5), n));
		int l = random(n - clen + 1) + 1;
		int q;
		if (random(100) >= p) q = 1; else q = 0;
		fprintf(f, "%d %d %d\n", q, l, l + clen - 1);
	}
}

int next(int i) {
	if (i <= 1000) return i + 823;
	if (i <= 10000) return i + 7023;
	if (i <= 100000) return i + 10023;
	if (i < 200000) return 200000;
	return 200001;
}

void tmp(int i)
{
    	eqSegmentLength(i, i - random(5), random(i / 2) + i / 2, i, 5);
    	eqSegmentLength(i, i - random(5), random(i / 2) + i / 2, i, 95);
    	eqSegmentLength(i, i - random(5), random(i / 2) + i / 2, i, 50 + (1 - 2 * random(2)) * random(20));
}

void readdata() {
	int i; 

    	tmp(200000);

}

int main() 
{
	readdata();
	solve();
	outdata();
	return 0;
}

