#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forv(i, a) for (int i = 0; i < int(a.size()); i++)
#define fors(i, a) for (int i = 0; i < int(a.length()); i++)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

#define C_IN_FILE "reverse.in"
#define C_OUT_FILE "reverse.out"

const int NMAX = 200000;

int n, m;
int a[NMAX];

long long sum(int l, int r) {
	long long ans = 0;
	for(int i = l; i <= r; ++i) ans += a[i];
	return ans;
}

void readdata() {
	assert(scanf("%d%d", &n, &m) == 2);
	assert(1 <= n && n <= 200000);
	assert(1 <= m && m <= 200000);
	forn(i, n) {
		assert(scanf("%d", &a[i]) == 1);
		assert(1 <= a[i] && a[i] <= 200000);
	}
	forn(i, m) {
		int q, l, r;
		assert(scanf("%d%d%d", &q, &l, &r) == 3);
		assert(0 <= q && q <= 1);
		assert(1 <= l && l <= r);
		assert(l <= r && r <= n);
		--l; --r;
		if (q == 1) reverse(a + l, a + r + 1); 
		else {
        #ifdef WIN32
            printf("%I64d\n", sum(l, r));
        #else
            printf("%lld\n", sum(l, r));
        #endif
        }
	}
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	return 0;
}
